#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами
#include <TimerThree.h> // Подключение библиотеки <TimerThree.h> для работы с таймером/счетчиком 3

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_START 13 // Назначение пина, к которому подключена тактовая кнопка запуска
#define BUTTON_STOP 5 // Назначение пина, к которому подключена тактовая кнопка остановки робота

volatile bool button_state=true; // Объявление переменной button_state и присвоение ей значения true
bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
volatile bool button_on=false; // Б.1 - Объявление переменной button_on и присвоение ей значения false

volatile int tick=0; // Б.1 - Объявление переменной tick и присвоение ей значения 0
volatile int counter_led=0; // Б.1 - Объявление переменной counter_led и присвоение ей значения 0
int speeds_right; // Объявление переменной speeds_right
int speeds_left; // Объявление переменной speeds_left
int moves; // Объявление переменной moves
int counter; // Объявление переменной counter

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
 
pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод
pinMode (BUTTON_STOP,INPUT); // Настройка пина BUTTON_STOP на ввод

Timer3.initialize(100000); // Б.1 - Настройка таймера/счетчика 3 на отсчет 0,1 с

}

void loop() {
  button_state=digitalRead(BUTTON_START); // Б.2 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.3 - Если значение переменной button_state равно 0, то 
  {
     delay(10); // Б.4 - Ожидание 0,01 с
     button_state=digitalRead(BUTTON_START); // Б.5 - Сохранение состояния на пине BUTTON_START в переменную button_state
     if(button_state==0) // Б.6 - Если значение переменной button_state равно 0, то 
     {
      do 
      {
        button_state=digitalRead(BUTTON_START); // Б.7 - Сохранение состояния на пине BUTTON_START в переменную button_state
      }
      while(button_state==0); // Б.8 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
      robot_state=true; // Б.9 - Присвоение переменной robot_state значение true       
      counter=0; // Б.10 - Присвоение переменной counter значения 0
      while(counter<3) // Б.11 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
      {
       digitalWrite(LEFT_LED,HIGH); // Б.12 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
       digitalWrite(RIGHT_LED,HIGH); // Б.12 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
       delay(500); // Б.13 - Ожидание 0,5 секунды
       digitalWrite(LEFT_LED,LOW); // Б.14 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
       digitalWrite(RIGHT_LED,LOW); // Б.14 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
       delay(500); // Б.15 - Ожидание 0,5 секунд
       counter=counter+1; // Б.16 - Увеличение значения переменной counter на 1
     }
     Timer3.attachInterrupt(delay_led); // Инициализация функции delay_led, вызываемой при возникновении прерывания таймера/счетчика 3
     }
  }  
    
  while(robot_state==true) // Б.17 - Выполнение инструкций в скобках пока значение переменной robot_state равно true     
  {
     speeds_right=rand()%56+45; // Б.18 - Присвоение переменной speeds_right случайного значения от 45 до 100
     speeds_left=rand()%56+45; // Б.18 - Присвоение переменной speeds_left случайного значения от 45 до 100
     moves=rand()%4+1; // Б.18 - Присвоение переменной moves произвольного значения от 1 до 4
     if(moves==1) // Б.19 - Если значение переменной moves равно 1, то начать выполнение операций в скобках
     {
     motor_right->forward(speeds_right); // Б.20 - Команда на запуск вращения мотора motor_right со скоростью speeds_right % в прямом направлении
     motor_left->forward(speeds_left); // Б.20 - Команда на запуск вращения мотора speeds_left со скоростью speeds_left % в прямом направлении
     }
     else if(moves==2) // Б.21 - Если значение переменной moves равно 2, то начать выполнение операций в скобках
     {
     motor_right->backward(speeds_right); // Б.22 - Команда на запуск вращения мотора motor_right со скоростью speeds_right % в обратном направлении
     motor_left->forward(speeds_left); // Б.22 - Команда на запуск вращения мотора speeds_left со скоростью speeds_left % в прямом направлении
     }
     else if(moves==3) // Б.23 - Если значение переменной moves равно 3, то начать выполнение операций в скобках
     {
     motor_right->forward(speeds_right); // Б.24 - Команда на запуск вращения мотора motor_right со скоростью speeds_right % в прямом направлении
     motor_left->backward(speeds_left); // Б.24 - Команда на запуск вращения мотора speeds_left со скоростью speeds_left % в обратном направлении
     }
     else  //Если ни одно из выше приведенных условий не выполнено, то начать выполнение операций в скобках
     {
     motor_right->backward(speeds_right); // Б.25 - Команда на запуск вращения мотора motor_right со скоростью speeds_right % в обратном направлении
     motor_left->backward(speeds_left); // Б.25 - Команда на запуск вращения мотора speeds_left со скоростью speeds_left % в обратном направлении
     }       
     delay(rand()%1000+500); // Б.26 - Ожидание в течение случайного интервала времени: от 0,5 до 1,5 с     
     if(tick==5) // Б.28 - Если значение переменной tick равно 5, то начать выполнение операций в скобках
      {
        tick=0; // Б.29 - Присвоение переменной tick значения 0
        robot_state=false; // Б.30 - Присвоение переменной robot_state значения false
        motor_right->stop(false); // Б.31 - Команда на остановку вращения мотора motor_right
        motor_left->stop(false); // Б.31 - Команда на остановку вращения мотора motor_left
        Timer3.detachInterrupt();
        digitalWrite(LEFT_LED,LOW); // Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
      }      
  }
}

void delay_led() // Б.27 - Функция-обработчик прерывания от таймера/счетчика 3
{
  if(button_on==true) // Б.27.1 - Если значение переменной button_on равно false, то начать выполнение операций в скобках
  {
  counter_led=counter_led+1; // Б.27.2 - Увеличение значения переменной tick на 1
  if(counter_led==20) // Б.27.3 - Если значение переменной counter_led равно 20, то начать выполнение операций в скобках
  {
   digitalWrite(LEFT_LED,LOW); // Б.27.4 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   button_on=false; // Б.27.5 - Присвоение переменной button_on значения false
   counter_led=0; // Б.27.6 - Присвоение переменной counter_led значения 0
  }
  }
  else // Иначе 
  {
  button_state=digitalRead(BUTTON_STOP); // Б.27.7 - Сохранение состояния на пине BUTTON_STOP в переменную button_state
  if(button_state==0) // Б.27.8 - Если значение переменной button_state равно 0, то 
  {              
      tick=tick+1; // Б.27.9 - Увеличение значения переменной tick на 1
      button_on=true; // Б.27.10 - Присвоение переменной button_on значение true 
      digitalWrite(LEFT_LED,HIGH); // Б.27.11 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
  }      
  }  
}
